;												
; SPI-MASTER fr ATmega8						
; Bernhard.Erfurt@gmx.de						
; 04/2013										
;												
;												

;												
; Anschlussbelegung PINS						
;												
; PB0 ==> 										
; PB1 ==> 										
; PB2 ==> SPI-CS								
; PB3 ==> MOSI									
; PB4 ==> MISO									
; PB5 ==> SCK									
; PB6 ==> 										
; PB7 ==> 										
;												
; PC0 ==> 										
; PC1 ==> 										
; PC2 ==> 										
; PC3 ==> 										
; PC4 ==> 										
; PC5 ==> 										
;												
; PD0 ==> 										
; PD1 ==> 										
; PD2 ==> 										
; PD3 ==> 										
; PD4 ==> 										
; PD5 ==> LED GRN								
; PD6 ==> LED GELB								
; PD7 ==> LED ROT								
;												


; ATmega8 										
.include "m8def.inc"
; SPI-CS										
.equ SPI_CS_PIN_NR					= 2
.equ SPI_CS_DDR						= DDRB
.equ SPI_CS_PORT					= PORTB
; SPI-MOSI										
.equ SPI_MOSI_PIN_NR				= 3
.equ SPI_MOSI_DDR					= DDRB
.equ SPI_MOSI_PORT		 			= PORTB
; SPI-MISO										
.equ SPI_MISO_PIN_NR				= 4
.equ SPI_MISO_DDR					= DDRB
.equ SPI_MISO_PORT		 			= PORTB
; SPI-SCK										
.equ SPI_SCK_PIN_NR					= 5
.equ SPI_SCK_DDR					= DDRB
.equ SPI_SCK_PORT		 			= PORTB

; LED-GRUEN										
.equ LED_GRUEN_PIN_NR				= 5
.equ LED_GRUEN_DDR					= DDRD
.equ LED_GRUEN_PORT					= PORTD
; LED-GELB										
.equ LED_GELB_PIN_NR				= 6
.equ LED_GELB_DDR					= DDRD
.equ LED_GELB_PORT					= PORTD
; LED-ROT										
.equ LED_ROT_PIN_NR					= 7
.equ LED_ROT_DDR					= DDRD
.equ LED_ROT_PORT					= PORTD
; LCD (DATA)									
.equ LCD_DATA0_DDR					= DDRC
.equ LCD_DATA1_DDR					= DDRC
.equ LCD_DATA2_DDR					= DDRC
.equ LCD_DATA3_DDR					= DDRC
.equ LCD_DATA0_PORT					= PORTC
.equ LCD_DATA1_PORT					= PORTC
.equ LCD_DATA2_PORT					= PORTC
.equ LCD_DATA3_PORT					= PORTC
.equ LCD_DATA0						= 0
.equ LCD_DATA1						= 1
.equ LCD_DATA2						= 2
.equ LCD_DATA3						= 3
; LCD RS (Befehl/DATEN)							
.equ LCD_RS_DDR						= DDRC
.equ LCD_RS_PORT					= PORTC
.equ LCD_RS							= 4
; LCD_ENABLE									
.equ LCD_E_DDR						= DDRC
.equ LCD_E_PORT						= PORTC
.equ LCD_E							= 5
; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN						=0x0060			; 0x0060 START Adresse 		
; REGISTER										

.def DUMMY_R0	= R0	; wichtige Hilfsregister (nicht verwenden !)
.def DUMMY_R1	= R1	; wichtige Hilfsregister (nicht verwenden !)

.def NULL 	= R12
.def EINS 	= R14
.def VOLL	= R15

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25





.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   	  	; Timer1 Overflow Handler       
rjmp INTERRUPT_ERROR	;rjmp TIM0_OVF   ; Timer0 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Unkorrekten Interrupt Aufruf 						
INTERRUPT_ERROR:
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	rcall wait_100ms
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus  
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	rcall wait_100ms
	rjmp INTERRUPT_ERROR

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM lschen										
	rcall SRAM_CLEAR
; PORT B initialisieren								
	ldi temp, 0b00000000	; 
	out DDRB, temp
; PORT B setzen										
	ldi temp, 0b00000000	; 
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b00000000	; 
	out DDRC, temp
; PORT C setzen										
	ldi temp, 0b00000000	; 
	out PORTC, temp				
; PORT D initialisieren								
	ldi temp, 0b00000000	; 
	out DDRD, temp
; PORT D setzen										
	ldi temp, 0b00000000	; 
	out PORTD, temp				
; LED-INITIALISIERUNG								
	rcall LED_INITIALISIERUNG
; WDR_INITIALISIERUNG								
	rcall WDR_INITIALISIERUNG
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
; SPI-INITIALISIERUNG								
	rcall SPI_INITIALISIERUNG
; Interrupts freigeben								
	sei
	rcall wait_1s
	; Bytes SENDEN
	ldi temp,1
	rcall SPI_SENDEN_EINLESEN_TEMP
	ldi temp,2
	rcall SPI_SENDEN_EINLESEN_TEMP
	ldi temp,3
	rcall SPI_SENDEN_EINLESEN_TEMP
	ldi temp,4
	rcall SPI_SENDEN_EINLESEN_TEMP
	ldi temp,5
	rcall SPI_SENDEN_EINLESEN_TEMP
	ldi temp,6
	rcall SPI_SENDEN_EINLESEN_TEMP
	ldi temp,7
	rcall SPI_SENDEN_EINLESEN_TEMP
	ldi temp,8
	rcall SPI_SENDEN_EINLESEN_TEMP
	ldi temp,9
	rcall SPI_SENDEN_EINLESEN_TEMP
	ldi temp,10
	rcall SPI_SENDEN_EINLESEN_TEMP
	; LED GRN			
	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an   
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR										; Watch-Dog-RESET	
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "SPIMA_SPI.asm"			; SPI							
.include "SPIMA_SONSTIGES.asm"		; sonstiges						
.include "SPIMA_WAIT_01MHZ.asm"		;  1 MHz						
; ##############################################################################
; ##############################################################################
; ##############################################################################
TEXT_BEGRUESSUNG_1:
.db "ATmega8",0
TEXT_BEGRUESSUNG_2:
.db "STANDARD ",0




